package br.org.indt.nokiatrends.osruntime;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

public class OSRunner
{
    public static final String localDir  = System.getProperty("user.dir");
    public static final String cmdProg   = "iexplore.exe";
    public static final String cmdParam1 = "file://" + localDir + "\\codeup\\open.html";
    public static Runtime rt             = Runtime.getRuntime();
    private String iePath                = "C:\\Program Files\\Internet Explorer";
    private Process proc                 = null;

    //private String photosDirectory = null;
    public OSRunner(String iePath)
    {
        if ((iePath != null) && (iePath.length() > 0))
        {
            this.iePath = iePath;
        }

        System.out.println("user.dir = " + localDir);

        //this.photosDirectory = phDir;
    }

    public boolean isProcessRunning()
    {
        return (proc != null);
    }

    public void killApp()
    {
        if (proc != null)
        {
            this.proc.destroy();
            this.proc = null;
        }
    }

    public void startApp() throws IOException
    {
        System.out.println("cmdLine = " + iePath + cmdProg + " " + cmdParam1);

        if (rt != null)
        {
            this.proc = rt.exec(new String[] { iePath+"\\"+cmdProg, cmdParam1 });
        }
        else
        {
            throw new IOException("Runtime is not initialized!");
        }
    }

    public void copyPhotoToCodeUp(String phAbsDir) throws IOException
    {
        System.out.println("cmdLine = copy " + phAbsDir + " " + localDir + "\\codeup");

        if (rt != null)
        {
            this.proc = rt.exec(new String[] { "copy", phAbsDir, localDir + "\\codeup" });
        }
        else
        {
            throw new IOException("Runtime is not initialized!");
        }
    }

    public void copyPhotoToCodeUpDir(File phDir) throws IOException
    {
        FileInputStream reader = new FileInputStream(phDir);
        System.out.println("localDir = " + localDir + "\\codeup\\foto.jpg");

        File flWr = new File(localDir + "\\codeup\\foto.jpg");

        if ((flWr != null) && flWr.exists() && flWr.isFile())
        {
            flWr.delete();
        }

        if ((flWr == null) || !flWr.createNewFile())
        {
            throw new IOException("Error creating file!");
        }

        FileOutputStream writer = new FileOutputStream(flWr);
        int i                   = 0;

        while ((i = reader.read()) != -1)
            writer.write(i);

        writer.flush();

        if (reader != null)
        {
            reader.close();
        }

        if (writer != null)
        {
            writer.close();
        }

        System.out.println("File copying processing finished");
    }

    public static final void main(String[] args)
    {
    }
}
